/*
 * This file is autogenerated with bcop:
 * The Compiz option code generator
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 */


#include <core/core.h>

#include "unityshell_options.h"

UnityshellOptions::UnityshellOptions (bool init /* = true */) :
    mOptions (UnityshellOptions::OptionNum),
    mNotify (UnityshellOptions::OptionNum)
{
    if (init)
        initOptions ();
}

void
UnityshellOptions::initOptions ()
{
    unsigned int state;
    CompAction action;
    unsigned short color[4];

    // show_menu_bar
    mOptions[UnityshellOptions::ShowMenuBar].setName ("show_menu_bar", CompOption::TypeKey);
    state = CompAction::StateAutoGrab;
    action = CompAction ();
    action.setState (state | CompAction::StateInitKey);
    action.keyFromString ("<Alt>");
    mOptions[UnityshellOptions::ShowMenuBar].value().set (action);
    if (screen) screen->addAction (&mOptions[UnityshellOptions::ShowMenuBar].value ().action ());

    // lock_screen
    mOptions[UnityshellOptions::LockScreen].setName ("lock_screen", CompOption::TypeKey);
    state = CompAction::StateAutoGrab;
    action = CompAction ();
    action.setState (state | CompAction::StateInitKey);
    action.keyFromString ("<Super>l");
    mOptions[UnityshellOptions::LockScreen].value().set (action);
    if (screen) screen->addAction (&mOptions[UnityshellOptions::LockScreen].value ().action ());

    // show_hud
    mOptions[UnityshellOptions::ShowHud].setName ("show_hud", CompOption::TypeKey);
    state = CompAction::StateAutoGrab;
    action = CompAction ();
    action.setState (state | CompAction::StateInitKey);
    action.keyFromString ("<Alt>");
    mOptions[UnityshellOptions::ShowHud].value().set (action);
    if (screen) screen->addAction (&mOptions[UnityshellOptions::ShowHud].value ().action ());

    // execute_command
    mOptions[UnityshellOptions::ExecuteCommand].setName ("execute_command", CompOption::TypeKey);
    state = CompAction::StateAutoGrab;
    action = CompAction ();
    action.setState (state | CompAction::StateInitKey);
    action.keyFromString ("<Alt>F2");
    mOptions[UnityshellOptions::ExecuteCommand].value().set (action);
    if (screen) screen->addAction (&mOptions[UnityshellOptions::ExecuteCommand].value ().action ());

    // show_desktop_key
    mOptions[UnityshellOptions::ShowDesktopKey].setName ("show_desktop_key", CompOption::TypeKey);
    state = CompAction::StateAutoGrab;
    action = CompAction ();
    action.setState (state | CompAction::StateInitKey);
    action.keyFromString ("<Control><Super>d");
    mOptions[UnityshellOptions::ShowDesktopKey].value().set (action);
    if (screen) screen->addAction (&mOptions[UnityshellOptions::ShowDesktopKey].value ().action ());

    // panel_first_menu
    mOptions[UnityshellOptions::PanelFirstMenu].setName ("panel_first_menu", CompOption::TypeKey);
    state = CompAction::StateAutoGrab;
    action = CompAction ();
    action.setState (state | CompAction::StateInitKey);
    action.keyFromString ("<Alt>F10");
    mOptions[UnityshellOptions::PanelFirstMenu].value().set (action);
    if (screen) screen->addAction (&mOptions[UnityshellOptions::PanelFirstMenu].value ().action ());

    // spread_app_windows
    mOptions[UnityshellOptions::SpreadAppWindows].setName ("spread_app_windows", CompOption::TypeKey);
    state = CompAction::StateAutoGrab;
    action = CompAction ();
    action.setState (state | CompAction::StateInitKey);
    action.keyFromString ("<Control><Super>w");
    mOptions[UnityshellOptions::SpreadAppWindows].value().set (action);
    if (screen) screen->addAction (&mOptions[UnityshellOptions::SpreadAppWindows].value ().action ());

    // spread_app_windows_anywhere
    mOptions[UnityshellOptions::SpreadAppWindowsAnywhere].setName ("spread_app_windows_anywhere", CompOption::TypeKey);
    state = CompAction::StateAutoGrab;
    action = CompAction ();
    action.setState (state | CompAction::StateInitKey);
    action.keyFromString ("<Control><Super><Shift>w");
    mOptions[UnityshellOptions::SpreadAppWindowsAnywhere].value().set (action);
    if (screen) screen->addAction (&mOptions[UnityshellOptions::SpreadAppWindowsAnywhere].value ().action ());

    // panel_opacity
    mOptions[UnityshellOptions::PanelOpacity].setName ("panel_opacity", CompOption::TypeFloat);
    mOptions[UnityshellOptions::PanelOpacity].rest ().set (0.1, 1.0, 0.01);
    mOptions[UnityshellOptions::PanelOpacity].value().set((float) 0.75);

    // panel_opacity_maximized_toggle
    mOptions[UnityshellOptions::PanelOpacityMaximizedToggle].setName ("panel_opacity_maximized_toggle", CompOption::TypeBool);
    mOptions[UnityshellOptions::PanelOpacityMaximizedToggle].value().set(false);

    // background_color
    mOptions[UnityshellOptions::BackgroundColor].setName ("background_color", CompOption::TypeColor);
    color[0] = MAX (0, MIN (0xffff, 0x00));
    color[1] = MAX (0, MIN (0xffff, 0x00));
    color[2] = MAX (0, MIN (0xffff, 0x00));
    color[3] = MAX (0, MIN (0xffff, 0x00));
    mOptions[UnityshellOptions::BackgroundColor].value().set(color);

    // dash_blur_experimental
    mOptions[UnityshellOptions::DashBlurExperimental].setName ("dash_blur_experimental", CompOption::TypeInt);
    mOptions[UnityshellOptions::DashBlurExperimental].rest ().set (0, 2);
    mOptions[UnityshellOptions::DashBlurExperimental].value().set((int) 2);

    // automaximize_value
    mOptions[UnityshellOptions::AutomaximizeValue].setName ("automaximize_value", CompOption::TypeInt);
    mOptions[UnityshellOptions::AutomaximizeValue].rest ().set (1, 100);
    mOptions[UnityshellOptions::AutomaximizeValue].value().set((int) 75);

    // shortcut_overlay
    mOptions[UnityshellOptions::ShortcutOverlay].setName ("shortcut_overlay", CompOption::TypeBool);
    mOptions[UnityshellOptions::ShortcutOverlay].value().set(true);

    // override_decoration_theme
    mOptions[UnityshellOptions::OverrideDecorationTheme].setName ("override_decoration_theme", CompOption::TypeBool);
    mOptions[UnityshellOptions::OverrideDecorationTheme].value().set(false);

    // shadow_x_offset
    mOptions[UnityshellOptions::ShadowXOffset].setName ("shadow_x_offset", CompOption::TypeInt);
    mOptions[UnityshellOptions::ShadowXOffset].rest ().set (-10, 10);
    mOptions[UnityshellOptions::ShadowXOffset].value().set((int) 1);

    // shadow_y_offset
    mOptions[UnityshellOptions::ShadowYOffset].setName ("shadow_y_offset", CompOption::TypeInt);
    mOptions[UnityshellOptions::ShadowYOffset].rest ().set (-10, 10);
    mOptions[UnityshellOptions::ShadowYOffset].value().set((int) 1);

    // active_shadow_radius
    mOptions[UnityshellOptions::ActiveShadowRadius].setName ("active_shadow_radius", CompOption::TypeInt);
    mOptions[UnityshellOptions::ActiveShadowRadius].rest ().set (1, 30);
    mOptions[UnityshellOptions::ActiveShadowRadius].value().set((int) 8);

    // active_shadow_color
    mOptions[UnityshellOptions::ActiveShadowColor].setName ("active_shadow_color", CompOption::TypeColor);
    color[0] = MAX (0, MIN (0xffff, 0));
    color[1] = MAX (0, MIN (0xffff, 0));
    color[2] = MAX (0, MIN (0xffff, 0));
    color[3] = MAX (0, MIN (0xffff, 0x6666));
    mOptions[UnityshellOptions::ActiveShadowColor].value().set(color);

    // inactive_shadow_radius
    mOptions[UnityshellOptions::InactiveShadowRadius].setName ("inactive_shadow_radius", CompOption::TypeInt);
    mOptions[UnityshellOptions::InactiveShadowRadius].rest ().set (1, 30);
    mOptions[UnityshellOptions::InactiveShadowRadius].value().set((int) 5);

    // inactive_shadow_color
    mOptions[UnityshellOptions::InactiveShadowColor].setName ("inactive_shadow_color", CompOption::TypeColor);
    color[0] = MAX (0, MIN (0xffff, 0));
    color[1] = MAX (0, MIN (0xffff, 0));
    color[2] = MAX (0, MIN (0xffff, 0));
    color[3] = MAX (0, MIN (0xffff, 0xa5a1));
    mOptions[UnityshellOptions::InactiveShadowColor].value().set(color);

    // show_launcher
    mOptions[UnityshellOptions::ShowLauncher].setName ("show_launcher", CompOption::TypeKey);
    state = CompAction::StateAutoGrab;
    action = CompAction ();
    action.setState (state | CompAction::StateInitKey);
    action.setState (action.state() | CompAction::StateIgnoreTap);
    action.keyFromString ("<Super>");
    mOptions[UnityshellOptions::ShowLauncher].value().set (action);
    if (screen) screen->addAction (&mOptions[UnityshellOptions::ShowLauncher].value ().action ());

    // keyboard_focus
    mOptions[UnityshellOptions::KeyboardFocus].setName ("keyboard_focus", CompOption::TypeKey);
    state = CompAction::StateAutoGrab;
    action = CompAction ();
    action.setState (state | CompAction::StateInitKey);
    action.keyFromString ("<Alt>F1");
    mOptions[UnityshellOptions::KeyboardFocus].value().set (action);
    if (screen) screen->addAction (&mOptions[UnityshellOptions::KeyboardFocus].value ().action ());

    // launcher_switcher_forward
    mOptions[UnityshellOptions::LauncherSwitcherForward].setName ("launcher_switcher_forward", CompOption::TypeKey);
    state = CompAction::StateAutoGrab;
    action = CompAction ();
    action.setState (state | CompAction::StateInitKey);
    action.keyFromString ("<Super>Tab");
    mOptions[UnityshellOptions::LauncherSwitcherForward].value().set (action);
    if (screen) screen->addAction (&mOptions[UnityshellOptions::LauncherSwitcherForward].value ().action ());

    // launcher_switcher_prev
    mOptions[UnityshellOptions::LauncherSwitcherPrev].setName ("launcher_switcher_prev", CompOption::TypeKey);
    state = CompAction::StateAutoGrab;
    action = CompAction ();
    action.setState (state | CompAction::StateInitKey);
    action.keyFromString ("<Super><Shift>Tab");
    mOptions[UnityshellOptions::LauncherSwitcherPrev].value().set (action);
    if (screen) screen->addAction (&mOptions[UnityshellOptions::LauncherSwitcherPrev].value ().action ());

    // dash_tap_duration
    mOptions[UnityshellOptions::DashTapDuration].setName ("dash_tap_duration", CompOption::TypeInt);
    mOptions[UnityshellOptions::DashTapDuration].rest ().set (1, 1000);
    mOptions[UnityshellOptions::DashTapDuration].value().set((int) 250);

    // launcher_opacity
    mOptions[UnityshellOptions::LauncherOpacity].setName ("launcher_opacity", CompOption::TypeFloat);
    mOptions[UnityshellOptions::LauncherOpacity].rest ().set (0.0, 1.0, 0.0001);
    mOptions[UnityshellOptions::LauncherOpacity].value().set((float) 0.6667);

    // launcher_hide_mode
    mOptions[UnityshellOptions::LauncherHideMode].setName ("launcher_hide_mode", CompOption::TypeInt);
    mOptions[UnityshellOptions::LauncherHideMode].rest ().set (0, 1);
    mOptions[UnityshellOptions::LauncherHideMode].value().set((int) 0);

    // autohide_animation
    mOptions[UnityshellOptions::AutohideAnimation].setName ("autohide_animation", CompOption::TypeInt);
    mOptions[UnityshellOptions::AutohideAnimation].rest ().set (0, 3);
    mOptions[UnityshellOptions::AutohideAnimation].value().set((int) 3);

    // reveal_trigger
    mOptions[UnityshellOptions::RevealTrigger].setName ("reveal_trigger", CompOption::TypeInt);
    mOptions[UnityshellOptions::RevealTrigger].rest ().set (0, 1);
    mOptions[UnityshellOptions::RevealTrigger].value().set((int) 0);

    // num_launchers
    mOptions[UnityshellOptions::NumLaunchers].setName ("num_launchers", CompOption::TypeInt);
    mOptions[UnityshellOptions::NumLaunchers].rest ().set (0, 1);
    mOptions[UnityshellOptions::NumLaunchers].value().set((int) 0);

    // launcher_capture_mouse
    mOptions[UnityshellOptions::LauncherCaptureMouse].setName ("launcher_capture_mouse", CompOption::TypeBool);
    mOptions[UnityshellOptions::LauncherCaptureMouse].value().set(true);

    // scroll_inactive_icons
    mOptions[UnityshellOptions::ScrollInactiveIcons].setName ("scroll_inactive_icons", CompOption::TypeBool);
    mOptions[UnityshellOptions::ScrollInactiveIcons].value().set(true);

    // launcher_minimize_window
    mOptions[UnityshellOptions::LauncherMinimizeWindow].setName ("launcher_minimize_window", CompOption::TypeBool);
    mOptions[UnityshellOptions::LauncherMinimizeWindow].value().set(false);

    // edge_responsiveness
    mOptions[UnityshellOptions::EdgeResponsiveness].setName ("edge_responsiveness", CompOption::TypeFloat);
    mOptions[UnityshellOptions::EdgeResponsiveness].rest ().set (0.2, 8.0, 0.1);
    mOptions[UnityshellOptions::EdgeResponsiveness].value().set((float) 2.0);

    // reveal_pressure
    mOptions[UnityshellOptions::RevealPressure].setName ("reveal_pressure", CompOption::TypeInt);
    mOptions[UnityshellOptions::RevealPressure].rest ().set (1, 1000);
    mOptions[UnityshellOptions::RevealPressure].value().set((int) 20);

    // overcome_pressure
    mOptions[UnityshellOptions::OvercomePressure].setName ("overcome_pressure", CompOption::TypeInt);
    mOptions[UnityshellOptions::OvercomePressure].rest ().set (1, 1000);
    mOptions[UnityshellOptions::OvercomePressure].value().set((int) 20);

    // decay_rate
    mOptions[UnityshellOptions::DecayRate].setName ("decay_rate", CompOption::TypeInt);
    mOptions[UnityshellOptions::DecayRate].rest ().set (1, 1000);
    mOptions[UnityshellOptions::DecayRate].value().set((int) 15);

    // stop_velocity
    mOptions[UnityshellOptions::StopVelocity].setName ("stop_velocity", CompOption::TypeInt);
    mOptions[UnityshellOptions::StopVelocity].rest ().set (1, 1000);
    mOptions[UnityshellOptions::StopVelocity].value().set((int) 65);

    // edge_passed_disabled_ms
    mOptions[UnityshellOptions::EdgePassedDisabledMs].setName ("edge_passed_disabled_ms", CompOption::TypeInt);
    mOptions[UnityshellOptions::EdgePassedDisabledMs].rest ().set (0, 5000);
    mOptions[UnityshellOptions::EdgePassedDisabledMs].value().set((int) 1000);

    // icon_size
    mOptions[UnityshellOptions::IconSize].setName ("icon_size", CompOption::TypeInt);
    mOptions[UnityshellOptions::IconSize].rest ().set (8, 64);
    mOptions[UnityshellOptions::IconSize].value().set((int) 44);

    // backlight_mode
    mOptions[UnityshellOptions::BacklightMode].setName ("backlight_mode", CompOption::TypeInt);
    mOptions[UnityshellOptions::BacklightMode].rest ().set (0, 4);
    mOptions[UnityshellOptions::BacklightMode].value().set((int) 4);

    // launch_animation
    mOptions[UnityshellOptions::LaunchAnimation].setName ("launch_animation", CompOption::TypeInt);
    mOptions[UnityshellOptions::LaunchAnimation].rest ().set (0, 2);
    mOptions[UnityshellOptions::LaunchAnimation].value().set((int) 1);

    // urgent_animation
    mOptions[UnityshellOptions::UrgentAnimation].setName ("urgent_animation", CompOption::TypeInt);
    mOptions[UnityshellOptions::UrgentAnimation].rest ().set (0, 2);
    mOptions[UnityshellOptions::UrgentAnimation].value().set((int) 2);

    // menus_fadein
    mOptions[UnityshellOptions::MenusFadein].setName ("menus_fadein", CompOption::TypeInt);
    mOptions[UnityshellOptions::MenusFadein].rest ().set (0, 1000);
    mOptions[UnityshellOptions::MenusFadein].value().set((int) 100);

    // menus_fadeout
    mOptions[UnityshellOptions::MenusFadeout].setName ("menus_fadeout", CompOption::TypeInt);
    mOptions[UnityshellOptions::MenusFadeout].rest ().set (0, 1000);
    mOptions[UnityshellOptions::MenusFadeout].value().set((int) 120);

    // menus_discovery_duration
    mOptions[UnityshellOptions::MenusDiscoveryDuration].setName ("menus_discovery_duration", CompOption::TypeInt);
    mOptions[UnityshellOptions::MenusDiscoveryDuration].rest ().set (0, 10);
    mOptions[UnityshellOptions::MenusDiscoveryDuration].value().set((int) 2);

    // menus_discovery_fadein
    mOptions[UnityshellOptions::MenusDiscoveryFadein].setName ("menus_discovery_fadein", CompOption::TypeInt);
    mOptions[UnityshellOptions::MenusDiscoveryFadein].rest ().set (0, 1000);
    mOptions[UnityshellOptions::MenusDiscoveryFadein].value().set((int) 200);

    // menus_discovery_fadeout
    mOptions[UnityshellOptions::MenusDiscoveryFadeout].setName ("menus_discovery_fadeout", CompOption::TypeInt);
    mOptions[UnityshellOptions::MenusDiscoveryFadeout].rest ().set (0, 1000);
    mOptions[UnityshellOptions::MenusDiscoveryFadeout].value().set((int) 300);

    // alt_tab_forward
    mOptions[UnityshellOptions::AltTabForward].setName ("alt_tab_forward", CompOption::TypeKey);
    state = CompAction::StateAutoGrab;
    action = CompAction ();
    action.setState (state | CompAction::StateInitKey);
    action.keyFromString ("<Alt>Tab");
    mOptions[UnityshellOptions::AltTabForward].value().set (action);
    if (screen) screen->addAction (&mOptions[UnityshellOptions::AltTabForward].value ().action ());

    // alt_tab_prev
    mOptions[UnityshellOptions::AltTabPrev].setName ("alt_tab_prev", CompOption::TypeKey);
    state = CompAction::StateAutoGrab;
    action = CompAction ();
    action.setState (state | CompAction::StateInitKey);
    action.keyFromString ("<Alt><Shift>Tab");
    mOptions[UnityshellOptions::AltTabPrev].value().set (action);
    if (screen) screen->addAction (&mOptions[UnityshellOptions::AltTabPrev].value ().action ());

    // alt_tab_forward_all
    mOptions[UnityshellOptions::AltTabForwardAll].setName ("alt_tab_forward_all", CompOption::TypeKey);
    state = CompAction::StateAutoGrab;
    action = CompAction ();
    action.setState (state | CompAction::StateInitKey);
    action.keyFromString ("<Control><Alt>Tab");
    mOptions[UnityshellOptions::AltTabForwardAll].value().set (action);
    if (screen) screen->addAction (&mOptions[UnityshellOptions::AltTabForwardAll].value ().action ());

    // alt_tab_prev_all
    mOptions[UnityshellOptions::AltTabPrevAll].setName ("alt_tab_prev_all", CompOption::TypeKey);
    state = CompAction::StateAutoGrab;
    action = CompAction ();
    action.setState (state | CompAction::StateInitKey);
    action.keyFromString ("<Control><Alt><Shift>Tab");
    mOptions[UnityshellOptions::AltTabPrevAll].value().set (action);
    if (screen) screen->addAction (&mOptions[UnityshellOptions::AltTabPrevAll].value ().action ());

    // alt_tab_next_window
    mOptions[UnityshellOptions::AltTabNextWindow].setName ("alt_tab_next_window", CompOption::TypeKey);
    state = 0;
    action = CompAction ();
    action.setState (state | CompAction::StateInitKey);
    mOptions[UnityshellOptions::AltTabNextWindow].value().set (action);

    // alt_tab_prev_window
    mOptions[UnityshellOptions::AltTabPrevWindow].setName ("alt_tab_prev_window", CompOption::TypeKey);
    state = 0;
    action = CompAction ();
    action.setState (state | CompAction::StateInitKey);
    mOptions[UnityshellOptions::AltTabPrevWindow].value().set (action);

    // switch_strictly_between_applications
    mOptions[UnityshellOptions::SwitchStrictlyBetweenApplications].setName ("switch_strictly_between_applications", CompOption::TypeBool);
    mOptions[UnityshellOptions::SwitchStrictlyBetweenApplications].value().set(false);

    // show_minimized_windows
    mOptions[UnityshellOptions::ShowMinimizedWindows].setName ("show_minimized_windows", CompOption::TypeBool);
    mOptions[UnityshellOptions::ShowMinimizedWindows].value().set(true);

    // alt_tab_timeout
    mOptions[UnityshellOptions::AltTabTimeout].setName ("alt_tab_timeout", CompOption::TypeBool);
    mOptions[UnityshellOptions::AltTabTimeout].value().set(true);

    // alt_tab_bias_viewport
    mOptions[UnityshellOptions::AltTabBiasViewport].setName ("alt_tab_bias_viewport", CompOption::TypeBool);
    mOptions[UnityshellOptions::AltTabBiasViewport].value().set(true);

    // disable_show_desktop
    mOptions[UnityshellOptions::DisableShowDesktop].setName ("disable_show_desktop", CompOption::TypeBool);
    mOptions[UnityshellOptions::DisableShowDesktop].value().set(false);

    // disable_mouse
    mOptions[UnityshellOptions::DisableMouse].setName ("disable_mouse", CompOption::TypeBool);
    mOptions[UnityshellOptions::DisableMouse].value().set(false);

}

UnityshellOptions::~UnityshellOptions ()
{
}


CompOption::Vector &
UnityshellOptions::getOptions ()
{
    return mOptions;
}

bool
UnityshellOptions::setOption (const CompString &name, CompOption::Value &value)
{
    CompOption   *o;
    unsigned int index;

    o = CompOption::findOption (mOptions, name, &index);

    if (!o)
        return false;

    switch (index)
    {
        case UnityshellOptions::ShowMenuBar:
            if (o->set (value))
            {
                if (!mNotify[UnityshellOptions::ShowMenuBar].empty ())
                    mNotify[UnityshellOptions::ShowMenuBar] (o, UnityshellOptions::ShowMenuBar);
                return true;
            }
            break;
        case UnityshellOptions::LockScreen:
            if (o->set (value))
            {
                if (!mNotify[UnityshellOptions::LockScreen].empty ())
                    mNotify[UnityshellOptions::LockScreen] (o, UnityshellOptions::LockScreen);
                return true;
            }
            break;
        case UnityshellOptions::ShowHud:
            if (o->set (value))
            {
                if (!mNotify[UnityshellOptions::ShowHud].empty ())
                    mNotify[UnityshellOptions::ShowHud] (o, UnityshellOptions::ShowHud);
                return true;
            }
            break;
        case UnityshellOptions::ExecuteCommand:
            if (o->set (value))
            {
                if (!mNotify[UnityshellOptions::ExecuteCommand].empty ())
                    mNotify[UnityshellOptions::ExecuteCommand] (o, UnityshellOptions::ExecuteCommand);
                return true;
            }
            break;
        case UnityshellOptions::ShowDesktopKey:
            if (o->set (value))
            {
                if (!mNotify[UnityshellOptions::ShowDesktopKey].empty ())
                    mNotify[UnityshellOptions::ShowDesktopKey] (o, UnityshellOptions::ShowDesktopKey);
                return true;
            }
            break;
        case UnityshellOptions::PanelFirstMenu:
            if (o->set (value))
            {
                if (!mNotify[UnityshellOptions::PanelFirstMenu].empty ())
                    mNotify[UnityshellOptions::PanelFirstMenu] (o, UnityshellOptions::PanelFirstMenu);
                return true;
            }
            break;
        case UnityshellOptions::SpreadAppWindows:
            if (o->set (value))
            {
                if (!mNotify[UnityshellOptions::SpreadAppWindows].empty ())
                    mNotify[UnityshellOptions::SpreadAppWindows] (o, UnityshellOptions::SpreadAppWindows);
                return true;
            }
            break;
        case UnityshellOptions::SpreadAppWindowsAnywhere:
            if (o->set (value))
            {
                if (!mNotify[UnityshellOptions::SpreadAppWindowsAnywhere].empty ())
                    mNotify[UnityshellOptions::SpreadAppWindowsAnywhere] (o, UnityshellOptions::SpreadAppWindowsAnywhere);
                return true;
            }
            break;
        case UnityshellOptions::PanelOpacity:
            if (o->set (value))
            {
                if (!mNotify[UnityshellOptions::PanelOpacity].empty ())
                    mNotify[UnityshellOptions::PanelOpacity] (o, UnityshellOptions::PanelOpacity);
                return true;
            }
            break;
        case UnityshellOptions::PanelOpacityMaximizedToggle:
            if (o->set (value))
            {
                if (!mNotify[UnityshellOptions::PanelOpacityMaximizedToggle].empty ())
                    mNotify[UnityshellOptions::PanelOpacityMaximizedToggle] (o, UnityshellOptions::PanelOpacityMaximizedToggle);
                return true;
            }
            break;
        case UnityshellOptions::BackgroundColor:
            if (o->set (value))
            {
                if (!mNotify[UnityshellOptions::BackgroundColor].empty ())
                    mNotify[UnityshellOptions::BackgroundColor] (o, UnityshellOptions::BackgroundColor);
                return true;
            }
            break;
        case UnityshellOptions::DashBlurExperimental:
            if (o->set (value))
            {
                if (!mNotify[UnityshellOptions::DashBlurExperimental].empty ())
                    mNotify[UnityshellOptions::DashBlurExperimental] (o, UnityshellOptions::DashBlurExperimental);
                return true;
            }
            break;
        case UnityshellOptions::AutomaximizeValue:
            if (o->set (value))
            {
                if (!mNotify[UnityshellOptions::AutomaximizeValue].empty ())
                    mNotify[UnityshellOptions::AutomaximizeValue] (o, UnityshellOptions::AutomaximizeValue);
                return true;
            }
            break;
        case UnityshellOptions::ShortcutOverlay:
            if (o->set (value))
            {
                if (!mNotify[UnityshellOptions::ShortcutOverlay].empty ())
                    mNotify[UnityshellOptions::ShortcutOverlay] (o, UnityshellOptions::ShortcutOverlay);
                return true;
            }
            break;
        case UnityshellOptions::OverrideDecorationTheme:
            if (o->set (value))
            {
                if (!mNotify[UnityshellOptions::OverrideDecorationTheme].empty ())
                    mNotify[UnityshellOptions::OverrideDecorationTheme] (o, UnityshellOptions::OverrideDecorationTheme);
                return true;
            }
            break;
        case UnityshellOptions::ShadowXOffset:
            if (o->set (value))
            {
                if (!mNotify[UnityshellOptions::ShadowXOffset].empty ())
                    mNotify[UnityshellOptions::ShadowXOffset] (o, UnityshellOptions::ShadowXOffset);
                return true;
            }
            break;
        case UnityshellOptions::ShadowYOffset:
            if (o->set (value))
            {
                if (!mNotify[UnityshellOptions::ShadowYOffset].empty ())
                    mNotify[UnityshellOptions::ShadowYOffset] (o, UnityshellOptions::ShadowYOffset);
                return true;
            }
            break;
        case UnityshellOptions::ActiveShadowRadius:
            if (o->set (value))
            {
                if (!mNotify[UnityshellOptions::ActiveShadowRadius].empty ())
                    mNotify[UnityshellOptions::ActiveShadowRadius] (o, UnityshellOptions::ActiveShadowRadius);
                return true;
            }
            break;
        case UnityshellOptions::ActiveShadowColor:
            if (o->set (value))
            {
                if (!mNotify[UnityshellOptions::ActiveShadowColor].empty ())
                    mNotify[UnityshellOptions::ActiveShadowColor] (o, UnityshellOptions::ActiveShadowColor);
                return true;
            }
            break;
        case UnityshellOptions::InactiveShadowRadius:
            if (o->set (value))
            {
                if (!mNotify[UnityshellOptions::InactiveShadowRadius].empty ())
                    mNotify[UnityshellOptions::InactiveShadowRadius] (o, UnityshellOptions::InactiveShadowRadius);
                return true;
            }
            break;
        case UnityshellOptions::InactiveShadowColor:
            if (o->set (value))
            {
                if (!mNotify[UnityshellOptions::InactiveShadowColor].empty ())
                    mNotify[UnityshellOptions::InactiveShadowColor] (o, UnityshellOptions::InactiveShadowColor);
                return true;
            }
            break;
        case UnityshellOptions::ShowLauncher:
            if (o->set (value))
            {
                if (!mNotify[UnityshellOptions::ShowLauncher].empty ())
                    mNotify[UnityshellOptions::ShowLauncher] (o, UnityshellOptions::ShowLauncher);
                return true;
            }
            break;
        case UnityshellOptions::KeyboardFocus:
            if (o->set (value))
            {
                if (!mNotify[UnityshellOptions::KeyboardFocus].empty ())
                    mNotify[UnityshellOptions::KeyboardFocus] (o, UnityshellOptions::KeyboardFocus);
                return true;
            }
            break;
        case UnityshellOptions::LauncherSwitcherForward:
            if (o->set (value))
            {
                if (!mNotify[UnityshellOptions::LauncherSwitcherForward].empty ())
                    mNotify[UnityshellOptions::LauncherSwitcherForward] (o, UnityshellOptions::LauncherSwitcherForward);
                return true;
            }
            break;
        case UnityshellOptions::LauncherSwitcherPrev:
            if (o->set (value))
            {
                if (!mNotify[UnityshellOptions::LauncherSwitcherPrev].empty ())
                    mNotify[UnityshellOptions::LauncherSwitcherPrev] (o, UnityshellOptions::LauncherSwitcherPrev);
                return true;
            }
            break;
        case UnityshellOptions::DashTapDuration:
            if (o->set (value))
            {
                if (!mNotify[UnityshellOptions::DashTapDuration].empty ())
                    mNotify[UnityshellOptions::DashTapDuration] (o, UnityshellOptions::DashTapDuration);
                return true;
            }
            break;
        case UnityshellOptions::LauncherOpacity:
            if (o->set (value))
            {
                if (!mNotify[UnityshellOptions::LauncherOpacity].empty ())
                    mNotify[UnityshellOptions::LauncherOpacity] (o, UnityshellOptions::LauncherOpacity);
                return true;
            }
            break;
        case UnityshellOptions::LauncherHideMode:
            if (o->set (value))
            {
                if (!mNotify[UnityshellOptions::LauncherHideMode].empty ())
                    mNotify[UnityshellOptions::LauncherHideMode] (o, UnityshellOptions::LauncherHideMode);
                return true;
            }
            break;
        case UnityshellOptions::AutohideAnimation:
            if (o->set (value))
            {
                if (!mNotify[UnityshellOptions::AutohideAnimation].empty ())
                    mNotify[UnityshellOptions::AutohideAnimation] (o, UnityshellOptions::AutohideAnimation);
                return true;
            }
            break;
        case UnityshellOptions::RevealTrigger:
            if (o->set (value))
            {
                if (!mNotify[UnityshellOptions::RevealTrigger].empty ())
                    mNotify[UnityshellOptions::RevealTrigger] (o, UnityshellOptions::RevealTrigger);
                return true;
            }
            break;
        case UnityshellOptions::NumLaunchers:
            if (o->set (value))
            {
                if (!mNotify[UnityshellOptions::NumLaunchers].empty ())
                    mNotify[UnityshellOptions::NumLaunchers] (o, UnityshellOptions::NumLaunchers);
                return true;
            }
            break;
        case UnityshellOptions::LauncherCaptureMouse:
            if (o->set (value))
            {
                if (!mNotify[UnityshellOptions::LauncherCaptureMouse].empty ())
                    mNotify[UnityshellOptions::LauncherCaptureMouse] (o, UnityshellOptions::LauncherCaptureMouse);
                return true;
            }
            break;
        case UnityshellOptions::ScrollInactiveIcons:
            if (o->set (value))
            {
                if (!mNotify[UnityshellOptions::ScrollInactiveIcons].empty ())
                    mNotify[UnityshellOptions::ScrollInactiveIcons] (o, UnityshellOptions::ScrollInactiveIcons);
                return true;
            }
            break;
        case UnityshellOptions::LauncherMinimizeWindow:
            if (o->set (value))
            {
                if (!mNotify[UnityshellOptions::LauncherMinimizeWindow].empty ())
                    mNotify[UnityshellOptions::LauncherMinimizeWindow] (o, UnityshellOptions::LauncherMinimizeWindow);
                return true;
            }
            break;
        case UnityshellOptions::EdgeResponsiveness:
            if (o->set (value))
            {
                if (!mNotify[UnityshellOptions::EdgeResponsiveness].empty ())
                    mNotify[UnityshellOptions::EdgeResponsiveness] (o, UnityshellOptions::EdgeResponsiveness);
                return true;
            }
            break;
        case UnityshellOptions::RevealPressure:
            if (o->set (value))
            {
                if (!mNotify[UnityshellOptions::RevealPressure].empty ())
                    mNotify[UnityshellOptions::RevealPressure] (o, UnityshellOptions::RevealPressure);
                return true;
            }
            break;
        case UnityshellOptions::OvercomePressure:
            if (o->set (value))
            {
                if (!mNotify[UnityshellOptions::OvercomePressure].empty ())
                    mNotify[UnityshellOptions::OvercomePressure] (o, UnityshellOptions::OvercomePressure);
                return true;
            }
            break;
        case UnityshellOptions::DecayRate:
            if (o->set (value))
            {
                if (!mNotify[UnityshellOptions::DecayRate].empty ())
                    mNotify[UnityshellOptions::DecayRate] (o, UnityshellOptions::DecayRate);
                return true;
            }
            break;
        case UnityshellOptions::StopVelocity:
            if (o->set (value))
            {
                if (!mNotify[UnityshellOptions::StopVelocity].empty ())
                    mNotify[UnityshellOptions::StopVelocity] (o, UnityshellOptions::StopVelocity);
                return true;
            }
            break;
        case UnityshellOptions::EdgePassedDisabledMs:
            if (o->set (value))
            {
                if (!mNotify[UnityshellOptions::EdgePassedDisabledMs].empty ())
                    mNotify[UnityshellOptions::EdgePassedDisabledMs] (o, UnityshellOptions::EdgePassedDisabledMs);
                return true;
            }
            break;
        case UnityshellOptions::IconSize:
            if (o->set (value))
            {
                if (!mNotify[UnityshellOptions::IconSize].empty ())
                    mNotify[UnityshellOptions::IconSize] (o, UnityshellOptions::IconSize);
                return true;
            }
            break;
        case UnityshellOptions::BacklightMode:
            if (o->set (value))
            {
                if (!mNotify[UnityshellOptions::BacklightMode].empty ())
                    mNotify[UnityshellOptions::BacklightMode] (o, UnityshellOptions::BacklightMode);
                return true;
            }
            break;
        case UnityshellOptions::LaunchAnimation:
            if (o->set (value))
            {
                if (!mNotify[UnityshellOptions::LaunchAnimation].empty ())
                    mNotify[UnityshellOptions::LaunchAnimation] (o, UnityshellOptions::LaunchAnimation);
                return true;
            }
            break;
        case UnityshellOptions::UrgentAnimation:
            if (o->set (value))
            {
                if (!mNotify[UnityshellOptions::UrgentAnimation].empty ())
                    mNotify[UnityshellOptions::UrgentAnimation] (o, UnityshellOptions::UrgentAnimation);
                return true;
            }
            break;
        case UnityshellOptions::MenusFadein:
            if (o->set (value))
            {
                if (!mNotify[UnityshellOptions::MenusFadein].empty ())
                    mNotify[UnityshellOptions::MenusFadein] (o, UnityshellOptions::MenusFadein);
                return true;
            }
            break;
        case UnityshellOptions::MenusFadeout:
            if (o->set (value))
            {
                if (!mNotify[UnityshellOptions::MenusFadeout].empty ())
                    mNotify[UnityshellOptions::MenusFadeout] (o, UnityshellOptions::MenusFadeout);
                return true;
            }
            break;
        case UnityshellOptions::MenusDiscoveryDuration:
            if (o->set (value))
            {
                if (!mNotify[UnityshellOptions::MenusDiscoveryDuration].empty ())
                    mNotify[UnityshellOptions::MenusDiscoveryDuration] (o, UnityshellOptions::MenusDiscoveryDuration);
                return true;
            }
            break;
        case UnityshellOptions::MenusDiscoveryFadein:
            if (o->set (value))
            {
                if (!mNotify[UnityshellOptions::MenusDiscoveryFadein].empty ())
                    mNotify[UnityshellOptions::MenusDiscoveryFadein] (o, UnityshellOptions::MenusDiscoveryFadein);
                return true;
            }
            break;
        case UnityshellOptions::MenusDiscoveryFadeout:
            if (o->set (value))
            {
                if (!mNotify[UnityshellOptions::MenusDiscoveryFadeout].empty ())
                    mNotify[UnityshellOptions::MenusDiscoveryFadeout] (o, UnityshellOptions::MenusDiscoveryFadeout);
                return true;
            }
            break;
        case UnityshellOptions::AltTabForward:
            if (o->set (value))
            {
                if (!mNotify[UnityshellOptions::AltTabForward].empty ())
                    mNotify[UnityshellOptions::AltTabForward] (o, UnityshellOptions::AltTabForward);
                return true;
            }
            break;
        case UnityshellOptions::AltTabPrev:
            if (o->set (value))
            {
                if (!mNotify[UnityshellOptions::AltTabPrev].empty ())
                    mNotify[UnityshellOptions::AltTabPrev] (o, UnityshellOptions::AltTabPrev);
                return true;
            }
            break;
        case UnityshellOptions::AltTabForwardAll:
            if (o->set (value))
            {
                if (!mNotify[UnityshellOptions::AltTabForwardAll].empty ())
                    mNotify[UnityshellOptions::AltTabForwardAll] (o, UnityshellOptions::AltTabForwardAll);
                return true;
            }
            break;
        case UnityshellOptions::AltTabPrevAll:
            if (o->set (value))
            {
                if (!mNotify[UnityshellOptions::AltTabPrevAll].empty ())
                    mNotify[UnityshellOptions::AltTabPrevAll] (o, UnityshellOptions::AltTabPrevAll);
                return true;
            }
            break;
        case UnityshellOptions::AltTabNextWindow:
            if (o->set (value))
            {
                if (!mNotify[UnityshellOptions::AltTabNextWindow].empty ())
                    mNotify[UnityshellOptions::AltTabNextWindow] (o, UnityshellOptions::AltTabNextWindow);
                return true;
            }
            break;
        case UnityshellOptions::AltTabPrevWindow:
            if (o->set (value))
            {
                if (!mNotify[UnityshellOptions::AltTabPrevWindow].empty ())
                    mNotify[UnityshellOptions::AltTabPrevWindow] (o, UnityshellOptions::AltTabPrevWindow);
                return true;
            }
            break;
        case UnityshellOptions::SwitchStrictlyBetweenApplications:
            if (o->set (value))
            {
                if (!mNotify[UnityshellOptions::SwitchStrictlyBetweenApplications].empty ())
                    mNotify[UnityshellOptions::SwitchStrictlyBetweenApplications] (o, UnityshellOptions::SwitchStrictlyBetweenApplications);
                return true;
            }
            break;
        case UnityshellOptions::ShowMinimizedWindows:
            if (o->set (value))
            {
                if (!mNotify[UnityshellOptions::ShowMinimizedWindows].empty ())
                    mNotify[UnityshellOptions::ShowMinimizedWindows] (o, UnityshellOptions::ShowMinimizedWindows);
                return true;
            }
            break;
        case UnityshellOptions::AltTabTimeout:
            if (o->set (value))
            {
                if (!mNotify[UnityshellOptions::AltTabTimeout].empty ())
                    mNotify[UnityshellOptions::AltTabTimeout] (o, UnityshellOptions::AltTabTimeout);
                return true;
            }
            break;
        case UnityshellOptions::AltTabBiasViewport:
            if (o->set (value))
            {
                if (!mNotify[UnityshellOptions::AltTabBiasViewport].empty ())
                    mNotify[UnityshellOptions::AltTabBiasViewport] (o, UnityshellOptions::AltTabBiasViewport);
                return true;
            }
            break;
        case UnityshellOptions::DisableShowDesktop:
            if (o->set (value))
            {
                if (!mNotify[UnityshellOptions::DisableShowDesktop].empty ())
                    mNotify[UnityshellOptions::DisableShowDesktop] (o, UnityshellOptions::DisableShowDesktop);
                return true;
            }
            break;
        case UnityshellOptions::DisableMouse:
            if (o->set (value))
            {
                if (!mNotify[UnityshellOptions::DisableMouse].empty ())
                    mNotify[UnityshellOptions::DisableMouse] (o, UnityshellOptions::DisableMouse);
                return true;
            }
            break;
        default:
            break;
    }
    return false;

}

