/*
 * This file is autogenerated with bcop:
 * The Compiz option code generator
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 */

#ifndef _UNITYSHELL_OPTIONS_H
#define _UNITYSHELL_OPTIONS_H

#include <core/core.h>

class UnityshellOptions : public CompOption::Class {
    public:
        enum Options {
            ShowMenuBar,
            LockScreen,
            ShowHud,
            ExecuteCommand,
            ShowDesktopKey,
            PanelFirstMenu,
            SpreadAppWindows,
            SpreadAppWindowsAnywhere,
            PanelOpacity,
            PanelOpacityMaximizedToggle,
            BackgroundColor,
            DashBlurExperimental,
            AutomaximizeValue,
            ShortcutOverlay,
            OverrideDecorationTheme,
            ShadowXOffset,
            ShadowYOffset,
            ActiveShadowRadius,
            ActiveShadowColor,
            InactiveShadowRadius,
            InactiveShadowColor,
            ShowLauncher,
            KeyboardFocus,
            LauncherSwitcherForward,
            LauncherSwitcherPrev,
            DashTapDuration,
            LauncherOpacity,
            LauncherHideMode,
            AutohideAnimation,
            RevealTrigger,
            NumLaunchers,
            LauncherCaptureMouse,
            ScrollInactiveIcons,
            LauncherMinimizeWindow,
            EdgeResponsiveness,
            RevealPressure,
            OvercomePressure,
            DecayRate,
            StopVelocity,
            EdgePassedDisabledMs,
            IconSize,
            BacklightMode,
            LaunchAnimation,
            UrgentAnimation,
            MenusFadein,
            MenusFadeout,
            MenusDiscoveryDuration,
            MenusDiscoveryFadein,
            MenusDiscoveryFadeout,
            AltTabForward,
            AltTabPrev,
            AltTabForwardAll,
            AltTabPrevAll,
            AltTabNextWindow,
            AltTabPrevWindow,
            SwitchStrictlyBetweenApplications,
            ShowMinimizedWindows,
            AltTabTimeout,
            AltTabBiasViewport,
            DisableShowDesktop,
            DisableMouse,
            OptionNum
        };

        enum DashBlurExperimental {
            DashBlurExperimentalNoBlur = 0,
            DashBlurExperimentalStaticBlur = 1,
            DashBlurExperimentalActiveBlur = 2,
        };

        enum LauncherHideMode {
            LauncherHideModeNever = 0,
            LauncherHideModeAutohide = 1,
        };

        enum AutohideAnimation {
            AutohideAnimationFadeOnBfbAndSlide = 0,
            AutohideAnimationSlideOnly = 1,
            AutohideAnimationFadeOnly = 2,
            AutohideAnimationFadeAndSlide = 3,
        };

        enum RevealTrigger {
            RevealTriggerLeftEdge = 0,
            RevealTriggerTopLeftCorner = 1,
        };

        enum NumLaunchers {
            NumLaunchersAllDisplays = 0,
            NumLaunchersPrimaryDisplay = 1,
        };

        enum BacklightMode {
            BacklightModeBacklightAlwaysOn = 0,
            BacklightModeBacklightToggles = 1,
            BacklightModeBacklightAlwaysOff = 2,
            BacklightModeEdgeIlluminationToggles = 3,
            BacklightModeBacklightAndEdgeIlluminationToggles = 4,
        };

        enum LaunchAnimation {
            LaunchAnimationNone = 0,
            LaunchAnimationPulseUntilRunning = 1,
            LaunchAnimationBlink = 2,
        };

        enum UrgentAnimation {
            UrgentAnimationNone = 0,
            UrgentAnimationPulse = 1,
            UrgentAnimationWiggle = 2,
        };

        typedef boost::function <void (CompOption *opt, Options num)> ChangeNotify;

        UnityshellOptions (bool init = true);
        virtual ~UnityshellOptions ();

	void initOptions ();

        virtual CompOption::Vector & getOptions ();
        virtual bool setOption (const CompString &name, CompOption::Value &value);

        CompAction & optionGetShowMenuBar ();
        void optionSetShowMenuBarInitiate (CompAction::CallBack init);
        void optionSetShowMenuBarTerminate (CompAction::CallBack term);
        void optionSetShowMenuBarNotify (ChangeNotify notify);

        CompAction & optionGetLockScreen ();
        void optionSetLockScreenInitiate (CompAction::CallBack init);
        void optionSetLockScreenTerminate (CompAction::CallBack term);
        void optionSetLockScreenNotify (ChangeNotify notify);

        CompAction & optionGetShowHud ();
        void optionSetShowHudInitiate (CompAction::CallBack init);
        void optionSetShowHudTerminate (CompAction::CallBack term);
        void optionSetShowHudNotify (ChangeNotify notify);

        CompAction & optionGetExecuteCommand ();
        void optionSetExecuteCommandInitiate (CompAction::CallBack init);
        void optionSetExecuteCommandTerminate (CompAction::CallBack term);
        void optionSetExecuteCommandNotify (ChangeNotify notify);

        CompAction & optionGetShowDesktopKey ();
        void optionSetShowDesktopKeyInitiate (CompAction::CallBack init);
        void optionSetShowDesktopKeyTerminate (CompAction::CallBack term);
        void optionSetShowDesktopKeyNotify (ChangeNotify notify);

        CompAction & optionGetPanelFirstMenu ();
        void optionSetPanelFirstMenuInitiate (CompAction::CallBack init);
        void optionSetPanelFirstMenuTerminate (CompAction::CallBack term);
        void optionSetPanelFirstMenuNotify (ChangeNotify notify);

        CompAction & optionGetSpreadAppWindows ();
        void optionSetSpreadAppWindowsInitiate (CompAction::CallBack init);
        void optionSetSpreadAppWindowsTerminate (CompAction::CallBack term);
        void optionSetSpreadAppWindowsNotify (ChangeNotify notify);

        CompAction & optionGetSpreadAppWindowsAnywhere ();
        void optionSetSpreadAppWindowsAnywhereInitiate (CompAction::CallBack init);
        void optionSetSpreadAppWindowsAnywhereTerminate (CompAction::CallBack term);
        void optionSetSpreadAppWindowsAnywhereNotify (ChangeNotify notify);

        float optionGetPanelOpacity ();
        void optionSetPanelOpacityNotify (ChangeNotify notify);

        bool optionGetPanelOpacityMaximizedToggle ();
        void optionSetPanelOpacityMaximizedToggleNotify (ChangeNotify notify);

        unsigned short * optionGetBackgroundColor ();
        unsigned short optionGetBackgroundColorRed ();
        unsigned short optionGetBackgroundColorGreen ();
        unsigned short optionGetBackgroundColorBlue ();
        unsigned short optionGetBackgroundColorAlpha ();
        void optionSetBackgroundColorNotify (ChangeNotify notify);

        int optionGetDashBlurExperimental ();
        void optionSetDashBlurExperimentalNotify (ChangeNotify notify);

        int optionGetAutomaximizeValue ();
        void optionSetAutomaximizeValueNotify (ChangeNotify notify);

        bool optionGetShortcutOverlay ();
        void optionSetShortcutOverlayNotify (ChangeNotify notify);

        bool optionGetOverrideDecorationTheme ();
        void optionSetOverrideDecorationThemeNotify (ChangeNotify notify);

        int optionGetShadowXOffset ();
        void optionSetShadowXOffsetNotify (ChangeNotify notify);

        int optionGetShadowYOffset ();
        void optionSetShadowYOffsetNotify (ChangeNotify notify);

        int optionGetActiveShadowRadius ();
        void optionSetActiveShadowRadiusNotify (ChangeNotify notify);

        unsigned short * optionGetActiveShadowColor ();
        unsigned short optionGetActiveShadowColorRed ();
        unsigned short optionGetActiveShadowColorGreen ();
        unsigned short optionGetActiveShadowColorBlue ();
        unsigned short optionGetActiveShadowColorAlpha ();
        void optionSetActiveShadowColorNotify (ChangeNotify notify);

        int optionGetInactiveShadowRadius ();
        void optionSetInactiveShadowRadiusNotify (ChangeNotify notify);

        unsigned short * optionGetInactiveShadowColor ();
        unsigned short optionGetInactiveShadowColorRed ();
        unsigned short optionGetInactiveShadowColorGreen ();
        unsigned short optionGetInactiveShadowColorBlue ();
        unsigned short optionGetInactiveShadowColorAlpha ();
        void optionSetInactiveShadowColorNotify (ChangeNotify notify);

        CompAction & optionGetShowLauncher ();
        void optionSetShowLauncherInitiate (CompAction::CallBack init);
        void optionSetShowLauncherTerminate (CompAction::CallBack term);
        void optionSetShowLauncherNotify (ChangeNotify notify);

        CompAction & optionGetKeyboardFocus ();
        void optionSetKeyboardFocusInitiate (CompAction::CallBack init);
        void optionSetKeyboardFocusTerminate (CompAction::CallBack term);
        void optionSetKeyboardFocusNotify (ChangeNotify notify);

        CompAction & optionGetLauncherSwitcherForward ();
        void optionSetLauncherSwitcherForwardInitiate (CompAction::CallBack init);
        void optionSetLauncherSwitcherForwardTerminate (CompAction::CallBack term);
        void optionSetLauncherSwitcherForwardNotify (ChangeNotify notify);

        CompAction & optionGetLauncherSwitcherPrev ();
        void optionSetLauncherSwitcherPrevInitiate (CompAction::CallBack init);
        void optionSetLauncherSwitcherPrevTerminate (CompAction::CallBack term);
        void optionSetLauncherSwitcherPrevNotify (ChangeNotify notify);

        int optionGetDashTapDuration ();
        void optionSetDashTapDurationNotify (ChangeNotify notify);

        float optionGetLauncherOpacity ();
        void optionSetLauncherOpacityNotify (ChangeNotify notify);

        int optionGetLauncherHideMode ();
        void optionSetLauncherHideModeNotify (ChangeNotify notify);

        int optionGetAutohideAnimation ();
        void optionSetAutohideAnimationNotify (ChangeNotify notify);

        int optionGetRevealTrigger ();
        void optionSetRevealTriggerNotify (ChangeNotify notify);

        int optionGetNumLaunchers ();
        void optionSetNumLaunchersNotify (ChangeNotify notify);

        bool optionGetLauncherCaptureMouse ();
        void optionSetLauncherCaptureMouseNotify (ChangeNotify notify);

        bool optionGetScrollInactiveIcons ();
        void optionSetScrollInactiveIconsNotify (ChangeNotify notify);

        bool optionGetLauncherMinimizeWindow ();
        void optionSetLauncherMinimizeWindowNotify (ChangeNotify notify);

        float optionGetEdgeResponsiveness ();
        void optionSetEdgeResponsivenessNotify (ChangeNotify notify);

        int optionGetRevealPressure ();
        void optionSetRevealPressureNotify (ChangeNotify notify);

        int optionGetOvercomePressure ();
        void optionSetOvercomePressureNotify (ChangeNotify notify);

        int optionGetDecayRate ();
        void optionSetDecayRateNotify (ChangeNotify notify);

        int optionGetStopVelocity ();
        void optionSetStopVelocityNotify (ChangeNotify notify);

        int optionGetEdgePassedDisabledMs ();
        void optionSetEdgePassedDisabledMsNotify (ChangeNotify notify);

        int optionGetIconSize ();
        void optionSetIconSizeNotify (ChangeNotify notify);

        int optionGetBacklightMode ();
        void optionSetBacklightModeNotify (ChangeNotify notify);

        int optionGetLaunchAnimation ();
        void optionSetLaunchAnimationNotify (ChangeNotify notify);

        int optionGetUrgentAnimation ();
        void optionSetUrgentAnimationNotify (ChangeNotify notify);

        int optionGetMenusFadein ();
        void optionSetMenusFadeinNotify (ChangeNotify notify);

        int optionGetMenusFadeout ();
        void optionSetMenusFadeoutNotify (ChangeNotify notify);

        int optionGetMenusDiscoveryDuration ();
        void optionSetMenusDiscoveryDurationNotify (ChangeNotify notify);

        int optionGetMenusDiscoveryFadein ();
        void optionSetMenusDiscoveryFadeinNotify (ChangeNotify notify);

        int optionGetMenusDiscoveryFadeout ();
        void optionSetMenusDiscoveryFadeoutNotify (ChangeNotify notify);

        CompAction & optionGetAltTabForward ();
        void optionSetAltTabForwardInitiate (CompAction::CallBack init);
        void optionSetAltTabForwardTerminate (CompAction::CallBack term);
        void optionSetAltTabForwardNotify (ChangeNotify notify);

        CompAction & optionGetAltTabPrev ();
        void optionSetAltTabPrevInitiate (CompAction::CallBack init);
        void optionSetAltTabPrevTerminate (CompAction::CallBack term);
        void optionSetAltTabPrevNotify (ChangeNotify notify);

        CompAction & optionGetAltTabForwardAll ();
        void optionSetAltTabForwardAllInitiate (CompAction::CallBack init);
        void optionSetAltTabForwardAllTerminate (CompAction::CallBack term);
        void optionSetAltTabForwardAllNotify (ChangeNotify notify);

        CompAction & optionGetAltTabPrevAll ();
        void optionSetAltTabPrevAllInitiate (CompAction::CallBack init);
        void optionSetAltTabPrevAllTerminate (CompAction::CallBack term);
        void optionSetAltTabPrevAllNotify (ChangeNotify notify);

        CompAction & optionGetAltTabNextWindow ();
        void optionSetAltTabNextWindowInitiate (CompAction::CallBack init);
        void optionSetAltTabNextWindowTerminate (CompAction::CallBack term);
        void optionSetAltTabNextWindowNotify (ChangeNotify notify);

        CompAction & optionGetAltTabPrevWindow ();
        void optionSetAltTabPrevWindowInitiate (CompAction::CallBack init);
        void optionSetAltTabPrevWindowTerminate (CompAction::CallBack term);
        void optionSetAltTabPrevWindowNotify (ChangeNotify notify);

        bool optionGetSwitchStrictlyBetweenApplications ();
        void optionSetSwitchStrictlyBetweenApplicationsNotify (ChangeNotify notify);

        bool optionGetShowMinimizedWindows ();
        void optionSetShowMinimizedWindowsNotify (ChangeNotify notify);

        bool optionGetAltTabTimeout ();
        void optionSetAltTabTimeoutNotify (ChangeNotify notify);

        bool optionGetAltTabBiasViewport ();
        void optionSetAltTabBiasViewportNotify (ChangeNotify notify);

        bool optionGetDisableShowDesktop ();
        void optionSetDisableShowDesktopNotify (ChangeNotify notify);

        bool optionGetDisableMouse ();
        void optionSetDisableMouseNotify (ChangeNotify notify);


    protected:
        CompOption::Vector mOptions;

    private:
        std::vector<ChangeNotify> mNotify;

};


inline CompAction &
UnityshellOptions::optionGetShowMenuBar ()
{
    return mOptions[UnityshellOptions::ShowMenuBar].value ().action ();
}

inline void
UnityshellOptions::optionSetShowMenuBarInitiate (CompAction::CallBack init)
{
    mOptions[UnityshellOptions::ShowMenuBar].value ().action ().setInitiate (init);
}

inline void
UnityshellOptions::optionSetShowMenuBarTerminate (CompAction::CallBack term)
{
    mOptions[UnityshellOptions::ShowMenuBar].value ().action ().setTerminate (term);
}

inline void
UnityshellOptions::optionSetShowMenuBarNotify (UnityshellOptions::ChangeNotify notify)
{
    mNotify[UnityshellOptions::ShowMenuBar] = notify;
}

inline CompAction &
UnityshellOptions::optionGetLockScreen ()
{
    return mOptions[UnityshellOptions::LockScreen].value ().action ();
}

inline void
UnityshellOptions::optionSetLockScreenInitiate (CompAction::CallBack init)
{
    mOptions[UnityshellOptions::LockScreen].value ().action ().setInitiate (init);
}

inline void
UnityshellOptions::optionSetLockScreenTerminate (CompAction::CallBack term)
{
    mOptions[UnityshellOptions::LockScreen].value ().action ().setTerminate (term);
}

inline void
UnityshellOptions::optionSetLockScreenNotify (UnityshellOptions::ChangeNotify notify)
{
    mNotify[UnityshellOptions::LockScreen] = notify;
}

inline CompAction &
UnityshellOptions::optionGetShowHud ()
{
    return mOptions[UnityshellOptions::ShowHud].value ().action ();
}

inline void
UnityshellOptions::optionSetShowHudInitiate (CompAction::CallBack init)
{
    mOptions[UnityshellOptions::ShowHud].value ().action ().setInitiate (init);
}

inline void
UnityshellOptions::optionSetShowHudTerminate (CompAction::CallBack term)
{
    mOptions[UnityshellOptions::ShowHud].value ().action ().setTerminate (term);
}

inline void
UnityshellOptions::optionSetShowHudNotify (UnityshellOptions::ChangeNotify notify)
{
    mNotify[UnityshellOptions::ShowHud] = notify;
}

inline CompAction &
UnityshellOptions::optionGetExecuteCommand ()
{
    return mOptions[UnityshellOptions::ExecuteCommand].value ().action ();
}

inline void
UnityshellOptions::optionSetExecuteCommandInitiate (CompAction::CallBack init)
{
    mOptions[UnityshellOptions::ExecuteCommand].value ().action ().setInitiate (init);
}

inline void
UnityshellOptions::optionSetExecuteCommandTerminate (CompAction::CallBack term)
{
    mOptions[UnityshellOptions::ExecuteCommand].value ().action ().setTerminate (term);
}

inline void
UnityshellOptions::optionSetExecuteCommandNotify (UnityshellOptions::ChangeNotify notify)
{
    mNotify[UnityshellOptions::ExecuteCommand] = notify;
}

inline CompAction &
UnityshellOptions::optionGetShowDesktopKey ()
{
    return mOptions[UnityshellOptions::ShowDesktopKey].value ().action ();
}

inline void
UnityshellOptions::optionSetShowDesktopKeyInitiate (CompAction::CallBack init)
{
    mOptions[UnityshellOptions::ShowDesktopKey].value ().action ().setInitiate (init);
}

inline void
UnityshellOptions::optionSetShowDesktopKeyTerminate (CompAction::CallBack term)
{
    mOptions[UnityshellOptions::ShowDesktopKey].value ().action ().setTerminate (term);
}

inline void
UnityshellOptions::optionSetShowDesktopKeyNotify (UnityshellOptions::ChangeNotify notify)
{
    mNotify[UnityshellOptions::ShowDesktopKey] = notify;
}

inline CompAction &
UnityshellOptions::optionGetPanelFirstMenu ()
{
    return mOptions[UnityshellOptions::PanelFirstMenu].value ().action ();
}

inline void
UnityshellOptions::optionSetPanelFirstMenuInitiate (CompAction::CallBack init)
{
    mOptions[UnityshellOptions::PanelFirstMenu].value ().action ().setInitiate (init);
}

inline void
UnityshellOptions::optionSetPanelFirstMenuTerminate (CompAction::CallBack term)
{
    mOptions[UnityshellOptions::PanelFirstMenu].value ().action ().setTerminate (term);
}

inline void
UnityshellOptions::optionSetPanelFirstMenuNotify (UnityshellOptions::ChangeNotify notify)
{
    mNotify[UnityshellOptions::PanelFirstMenu] = notify;
}

inline CompAction &
UnityshellOptions::optionGetSpreadAppWindows ()
{
    return mOptions[UnityshellOptions::SpreadAppWindows].value ().action ();
}

inline void
UnityshellOptions::optionSetSpreadAppWindowsInitiate (CompAction::CallBack init)
{
    mOptions[UnityshellOptions::SpreadAppWindows].value ().action ().setInitiate (init);
}

inline void
UnityshellOptions::optionSetSpreadAppWindowsTerminate (CompAction::CallBack term)
{
    mOptions[UnityshellOptions::SpreadAppWindows].value ().action ().setTerminate (term);
}

inline void
UnityshellOptions::optionSetSpreadAppWindowsNotify (UnityshellOptions::ChangeNotify notify)
{
    mNotify[UnityshellOptions::SpreadAppWindows] = notify;
}

inline CompAction &
UnityshellOptions::optionGetSpreadAppWindowsAnywhere ()
{
    return mOptions[UnityshellOptions::SpreadAppWindowsAnywhere].value ().action ();
}

inline void
UnityshellOptions::optionSetSpreadAppWindowsAnywhereInitiate (CompAction::CallBack init)
{
    mOptions[UnityshellOptions::SpreadAppWindowsAnywhere].value ().action ().setInitiate (init);
}

inline void
UnityshellOptions::optionSetSpreadAppWindowsAnywhereTerminate (CompAction::CallBack term)
{
    mOptions[UnityshellOptions::SpreadAppWindowsAnywhere].value ().action ().setTerminate (term);
}

inline void
UnityshellOptions::optionSetSpreadAppWindowsAnywhereNotify (UnityshellOptions::ChangeNotify notify)
{
    mNotify[UnityshellOptions::SpreadAppWindowsAnywhere] = notify;
}

inline float
UnityshellOptions::optionGetPanelOpacity ()
{
    return mOptions[UnityshellOptions::PanelOpacity].value ().f ();
}

inline void
UnityshellOptions::optionSetPanelOpacityNotify (UnityshellOptions::ChangeNotify notify)
{
    mNotify[UnityshellOptions::PanelOpacity] = notify;
}

inline bool
UnityshellOptions::optionGetPanelOpacityMaximizedToggle ()
{
    return mOptions[UnityshellOptions::PanelOpacityMaximizedToggle].value ().b ();
}

inline void
UnityshellOptions::optionSetPanelOpacityMaximizedToggleNotify (UnityshellOptions::ChangeNotify notify)
{
    mNotify[UnityshellOptions::PanelOpacityMaximizedToggle] = notify;
}

inline unsigned short *
UnityshellOptions::optionGetBackgroundColor ()
{
    return mOptions[UnityshellOptions::BackgroundColor].value ().c ();
}

inline unsigned short
UnityshellOptions::optionGetBackgroundColorRed ()
{
    return mOptions[UnityshellOptions::BackgroundColor].value ().c ()[0];
}

inline unsigned short
UnityshellOptions::optionGetBackgroundColorGreen ()
{
    return mOptions[UnityshellOptions::BackgroundColor].value ().c ()[1];
}


inline unsigned short
UnityshellOptions::optionGetBackgroundColorBlue ()
{
    return mOptions[UnityshellOptions::BackgroundColor].value ().c ()[2];
}


inline unsigned short
UnityshellOptions::optionGetBackgroundColorAlpha ()
{
    return mOptions[UnityshellOptions::BackgroundColor].value ().c ()[3];
}


inline void
UnityshellOptions::optionSetBackgroundColorNotify (UnityshellOptions::ChangeNotify notify)
{
    mNotify[UnityshellOptions::BackgroundColor] = notify;
}

inline int
UnityshellOptions::optionGetDashBlurExperimental ()
{
    return mOptions[UnityshellOptions::DashBlurExperimental].value ().i ();
}

inline void
UnityshellOptions::optionSetDashBlurExperimentalNotify (UnityshellOptions::ChangeNotify notify)
{
    mNotify[UnityshellOptions::DashBlurExperimental] = notify;
}

inline int
UnityshellOptions::optionGetAutomaximizeValue ()
{
    return mOptions[UnityshellOptions::AutomaximizeValue].value ().i ();
}

inline void
UnityshellOptions::optionSetAutomaximizeValueNotify (UnityshellOptions::ChangeNotify notify)
{
    mNotify[UnityshellOptions::AutomaximizeValue] = notify;
}

inline bool
UnityshellOptions::optionGetShortcutOverlay ()
{
    return mOptions[UnityshellOptions::ShortcutOverlay].value ().b ();
}

inline void
UnityshellOptions::optionSetShortcutOverlayNotify (UnityshellOptions::ChangeNotify notify)
{
    mNotify[UnityshellOptions::ShortcutOverlay] = notify;
}

inline bool
UnityshellOptions::optionGetOverrideDecorationTheme ()
{
    return mOptions[UnityshellOptions::OverrideDecorationTheme].value ().b ();
}

inline void
UnityshellOptions::optionSetOverrideDecorationThemeNotify (UnityshellOptions::ChangeNotify notify)
{
    mNotify[UnityshellOptions::OverrideDecorationTheme] = notify;
}

inline int
UnityshellOptions::optionGetShadowXOffset ()
{
    return mOptions[UnityshellOptions::ShadowXOffset].value ().i ();
}

inline void
UnityshellOptions::optionSetShadowXOffsetNotify (UnityshellOptions::ChangeNotify notify)
{
    mNotify[UnityshellOptions::ShadowXOffset] = notify;
}

inline int
UnityshellOptions::optionGetShadowYOffset ()
{
    return mOptions[UnityshellOptions::ShadowYOffset].value ().i ();
}

inline void
UnityshellOptions::optionSetShadowYOffsetNotify (UnityshellOptions::ChangeNotify notify)
{
    mNotify[UnityshellOptions::ShadowYOffset] = notify;
}

inline int
UnityshellOptions::optionGetActiveShadowRadius ()
{
    return mOptions[UnityshellOptions::ActiveShadowRadius].value ().i ();
}

inline void
UnityshellOptions::optionSetActiveShadowRadiusNotify (UnityshellOptions::ChangeNotify notify)
{
    mNotify[UnityshellOptions::ActiveShadowRadius] = notify;
}

inline unsigned short *
UnityshellOptions::optionGetActiveShadowColor ()
{
    return mOptions[UnityshellOptions::ActiveShadowColor].value ().c ();
}

inline unsigned short
UnityshellOptions::optionGetActiveShadowColorRed ()
{
    return mOptions[UnityshellOptions::ActiveShadowColor].value ().c ()[0];
}

inline unsigned short
UnityshellOptions::optionGetActiveShadowColorGreen ()
{
    return mOptions[UnityshellOptions::ActiveShadowColor].value ().c ()[1];
}


inline unsigned short
UnityshellOptions::optionGetActiveShadowColorBlue ()
{
    return mOptions[UnityshellOptions::ActiveShadowColor].value ().c ()[2];
}


inline unsigned short
UnityshellOptions::optionGetActiveShadowColorAlpha ()
{
    return mOptions[UnityshellOptions::ActiveShadowColor].value ().c ()[3];
}


inline void
UnityshellOptions::optionSetActiveShadowColorNotify (UnityshellOptions::ChangeNotify notify)
{
    mNotify[UnityshellOptions::ActiveShadowColor] = notify;
}

inline int
UnityshellOptions::optionGetInactiveShadowRadius ()
{
    return mOptions[UnityshellOptions::InactiveShadowRadius].value ().i ();
}

inline void
UnityshellOptions::optionSetInactiveShadowRadiusNotify (UnityshellOptions::ChangeNotify notify)
{
    mNotify[UnityshellOptions::InactiveShadowRadius] = notify;
}

inline unsigned short *
UnityshellOptions::optionGetInactiveShadowColor ()
{
    return mOptions[UnityshellOptions::InactiveShadowColor].value ().c ();
}

inline unsigned short
UnityshellOptions::optionGetInactiveShadowColorRed ()
{
    return mOptions[UnityshellOptions::InactiveShadowColor].value ().c ()[0];
}

inline unsigned short
UnityshellOptions::optionGetInactiveShadowColorGreen ()
{
    return mOptions[UnityshellOptions::InactiveShadowColor].value ().c ()[1];
}


inline unsigned short
UnityshellOptions::optionGetInactiveShadowColorBlue ()
{
    return mOptions[UnityshellOptions::InactiveShadowColor].value ().c ()[2];
}


inline unsigned short
UnityshellOptions::optionGetInactiveShadowColorAlpha ()
{
    return mOptions[UnityshellOptions::InactiveShadowColor].value ().c ()[3];
}


inline void
UnityshellOptions::optionSetInactiveShadowColorNotify (UnityshellOptions::ChangeNotify notify)
{
    mNotify[UnityshellOptions::InactiveShadowColor] = notify;
}

inline CompAction &
UnityshellOptions::optionGetShowLauncher ()
{
    return mOptions[UnityshellOptions::ShowLauncher].value ().action ();
}

inline void
UnityshellOptions::optionSetShowLauncherInitiate (CompAction::CallBack init)
{
    mOptions[UnityshellOptions::ShowLauncher].value ().action ().setInitiate (init);
}

inline void
UnityshellOptions::optionSetShowLauncherTerminate (CompAction::CallBack term)
{
    mOptions[UnityshellOptions::ShowLauncher].value ().action ().setTerminate (term);
}

inline void
UnityshellOptions::optionSetShowLauncherNotify (UnityshellOptions::ChangeNotify notify)
{
    mNotify[UnityshellOptions::ShowLauncher] = notify;
}

inline CompAction &
UnityshellOptions::optionGetKeyboardFocus ()
{
    return mOptions[UnityshellOptions::KeyboardFocus].value ().action ();
}

inline void
UnityshellOptions::optionSetKeyboardFocusInitiate (CompAction::CallBack init)
{
    mOptions[UnityshellOptions::KeyboardFocus].value ().action ().setInitiate (init);
}

inline void
UnityshellOptions::optionSetKeyboardFocusTerminate (CompAction::CallBack term)
{
    mOptions[UnityshellOptions::KeyboardFocus].value ().action ().setTerminate (term);
}

inline void
UnityshellOptions::optionSetKeyboardFocusNotify (UnityshellOptions::ChangeNotify notify)
{
    mNotify[UnityshellOptions::KeyboardFocus] = notify;
}

inline CompAction &
UnityshellOptions::optionGetLauncherSwitcherForward ()
{
    return mOptions[UnityshellOptions::LauncherSwitcherForward].value ().action ();
}

inline void
UnityshellOptions::optionSetLauncherSwitcherForwardInitiate (CompAction::CallBack init)
{
    mOptions[UnityshellOptions::LauncherSwitcherForward].value ().action ().setInitiate (init);
}

inline void
UnityshellOptions::optionSetLauncherSwitcherForwardTerminate (CompAction::CallBack term)
{
    mOptions[UnityshellOptions::LauncherSwitcherForward].value ().action ().setTerminate (term);
}

inline void
UnityshellOptions::optionSetLauncherSwitcherForwardNotify (UnityshellOptions::ChangeNotify notify)
{
    mNotify[UnityshellOptions::LauncherSwitcherForward] = notify;
}

inline CompAction &
UnityshellOptions::optionGetLauncherSwitcherPrev ()
{
    return mOptions[UnityshellOptions::LauncherSwitcherPrev].value ().action ();
}

inline void
UnityshellOptions::optionSetLauncherSwitcherPrevInitiate (CompAction::CallBack init)
{
    mOptions[UnityshellOptions::LauncherSwitcherPrev].value ().action ().setInitiate (init);
}

inline void
UnityshellOptions::optionSetLauncherSwitcherPrevTerminate (CompAction::CallBack term)
{
    mOptions[UnityshellOptions::LauncherSwitcherPrev].value ().action ().setTerminate (term);
}

inline void
UnityshellOptions::optionSetLauncherSwitcherPrevNotify (UnityshellOptions::ChangeNotify notify)
{
    mNotify[UnityshellOptions::LauncherSwitcherPrev] = notify;
}

inline int
UnityshellOptions::optionGetDashTapDuration ()
{
    return mOptions[UnityshellOptions::DashTapDuration].value ().i ();
}

inline void
UnityshellOptions::optionSetDashTapDurationNotify (UnityshellOptions::ChangeNotify notify)
{
    mNotify[UnityshellOptions::DashTapDuration] = notify;
}

inline float
UnityshellOptions::optionGetLauncherOpacity ()
{
    return mOptions[UnityshellOptions::LauncherOpacity].value ().f ();
}

inline void
UnityshellOptions::optionSetLauncherOpacityNotify (UnityshellOptions::ChangeNotify notify)
{
    mNotify[UnityshellOptions::LauncherOpacity] = notify;
}

inline int
UnityshellOptions::optionGetLauncherHideMode ()
{
    return mOptions[UnityshellOptions::LauncherHideMode].value ().i ();
}

inline void
UnityshellOptions::optionSetLauncherHideModeNotify (UnityshellOptions::ChangeNotify notify)
{
    mNotify[UnityshellOptions::LauncherHideMode] = notify;
}

inline int
UnityshellOptions::optionGetAutohideAnimation ()
{
    return mOptions[UnityshellOptions::AutohideAnimation].value ().i ();
}

inline void
UnityshellOptions::optionSetAutohideAnimationNotify (UnityshellOptions::ChangeNotify notify)
{
    mNotify[UnityshellOptions::AutohideAnimation] = notify;
}

inline int
UnityshellOptions::optionGetRevealTrigger ()
{
    return mOptions[UnityshellOptions::RevealTrigger].value ().i ();
}

inline void
UnityshellOptions::optionSetRevealTriggerNotify (UnityshellOptions::ChangeNotify notify)
{
    mNotify[UnityshellOptions::RevealTrigger] = notify;
}

inline int
UnityshellOptions::optionGetNumLaunchers ()
{
    return mOptions[UnityshellOptions::NumLaunchers].value ().i ();
}

inline void
UnityshellOptions::optionSetNumLaunchersNotify (UnityshellOptions::ChangeNotify notify)
{
    mNotify[UnityshellOptions::NumLaunchers] = notify;
}

inline bool
UnityshellOptions::optionGetLauncherCaptureMouse ()
{
    return mOptions[UnityshellOptions::LauncherCaptureMouse].value ().b ();
}

inline void
UnityshellOptions::optionSetLauncherCaptureMouseNotify (UnityshellOptions::ChangeNotify notify)
{
    mNotify[UnityshellOptions::LauncherCaptureMouse] = notify;
}

inline bool
UnityshellOptions::optionGetScrollInactiveIcons ()
{
    return mOptions[UnityshellOptions::ScrollInactiveIcons].value ().b ();
}

inline void
UnityshellOptions::optionSetScrollInactiveIconsNotify (UnityshellOptions::ChangeNotify notify)
{
    mNotify[UnityshellOptions::ScrollInactiveIcons] = notify;
}

inline bool
UnityshellOptions::optionGetLauncherMinimizeWindow ()
{
    return mOptions[UnityshellOptions::LauncherMinimizeWindow].value ().b ();
}

inline void
UnityshellOptions::optionSetLauncherMinimizeWindowNotify (UnityshellOptions::ChangeNotify notify)
{
    mNotify[UnityshellOptions::LauncherMinimizeWindow] = notify;
}

inline float
UnityshellOptions::optionGetEdgeResponsiveness ()
{
    return mOptions[UnityshellOptions::EdgeResponsiveness].value ().f ();
}

inline void
UnityshellOptions::optionSetEdgeResponsivenessNotify (UnityshellOptions::ChangeNotify notify)
{
    mNotify[UnityshellOptions::EdgeResponsiveness] = notify;
}

inline int
UnityshellOptions::optionGetRevealPressure ()
{
    return mOptions[UnityshellOptions::RevealPressure].value ().i ();
}

inline void
UnityshellOptions::optionSetRevealPressureNotify (UnityshellOptions::ChangeNotify notify)
{
    mNotify[UnityshellOptions::RevealPressure] = notify;
}

inline int
UnityshellOptions::optionGetOvercomePressure ()
{
    return mOptions[UnityshellOptions::OvercomePressure].value ().i ();
}

inline void
UnityshellOptions::optionSetOvercomePressureNotify (UnityshellOptions::ChangeNotify notify)
{
    mNotify[UnityshellOptions::OvercomePressure] = notify;
}

inline int
UnityshellOptions::optionGetDecayRate ()
{
    return mOptions[UnityshellOptions::DecayRate].value ().i ();
}

inline void
UnityshellOptions::optionSetDecayRateNotify (UnityshellOptions::ChangeNotify notify)
{
    mNotify[UnityshellOptions::DecayRate] = notify;
}

inline int
UnityshellOptions::optionGetStopVelocity ()
{
    return mOptions[UnityshellOptions::StopVelocity].value ().i ();
}

inline void
UnityshellOptions::optionSetStopVelocityNotify (UnityshellOptions::ChangeNotify notify)
{
    mNotify[UnityshellOptions::StopVelocity] = notify;
}

inline int
UnityshellOptions::optionGetEdgePassedDisabledMs ()
{
    return mOptions[UnityshellOptions::EdgePassedDisabledMs].value ().i ();
}

inline void
UnityshellOptions::optionSetEdgePassedDisabledMsNotify (UnityshellOptions::ChangeNotify notify)
{
    mNotify[UnityshellOptions::EdgePassedDisabledMs] = notify;
}

inline int
UnityshellOptions::optionGetIconSize ()
{
    return mOptions[UnityshellOptions::IconSize].value ().i ();
}

inline void
UnityshellOptions::optionSetIconSizeNotify (UnityshellOptions::ChangeNotify notify)
{
    mNotify[UnityshellOptions::IconSize] = notify;
}

inline int
UnityshellOptions::optionGetBacklightMode ()
{
    return mOptions[UnityshellOptions::BacklightMode].value ().i ();
}

inline void
UnityshellOptions::optionSetBacklightModeNotify (UnityshellOptions::ChangeNotify notify)
{
    mNotify[UnityshellOptions::BacklightMode] = notify;
}

inline int
UnityshellOptions::optionGetLaunchAnimation ()
{
    return mOptions[UnityshellOptions::LaunchAnimation].value ().i ();
}

inline void
UnityshellOptions::optionSetLaunchAnimationNotify (UnityshellOptions::ChangeNotify notify)
{
    mNotify[UnityshellOptions::LaunchAnimation] = notify;
}

inline int
UnityshellOptions::optionGetUrgentAnimation ()
{
    return mOptions[UnityshellOptions::UrgentAnimation].value ().i ();
}

inline void
UnityshellOptions::optionSetUrgentAnimationNotify (UnityshellOptions::ChangeNotify notify)
{
    mNotify[UnityshellOptions::UrgentAnimation] = notify;
}

inline int
UnityshellOptions::optionGetMenusFadein ()
{
    return mOptions[UnityshellOptions::MenusFadein].value ().i ();
}

inline void
UnityshellOptions::optionSetMenusFadeinNotify (UnityshellOptions::ChangeNotify notify)
{
    mNotify[UnityshellOptions::MenusFadein] = notify;
}

inline int
UnityshellOptions::optionGetMenusFadeout ()
{
    return mOptions[UnityshellOptions::MenusFadeout].value ().i ();
}

inline void
UnityshellOptions::optionSetMenusFadeoutNotify (UnityshellOptions::ChangeNotify notify)
{
    mNotify[UnityshellOptions::MenusFadeout] = notify;
}

inline int
UnityshellOptions::optionGetMenusDiscoveryDuration ()
{
    return mOptions[UnityshellOptions::MenusDiscoveryDuration].value ().i ();
}

inline void
UnityshellOptions::optionSetMenusDiscoveryDurationNotify (UnityshellOptions::ChangeNotify notify)
{
    mNotify[UnityshellOptions::MenusDiscoveryDuration] = notify;
}

inline int
UnityshellOptions::optionGetMenusDiscoveryFadein ()
{
    return mOptions[UnityshellOptions::MenusDiscoveryFadein].value ().i ();
}

inline void
UnityshellOptions::optionSetMenusDiscoveryFadeinNotify (UnityshellOptions::ChangeNotify notify)
{
    mNotify[UnityshellOptions::MenusDiscoveryFadein] = notify;
}

inline int
UnityshellOptions::optionGetMenusDiscoveryFadeout ()
{
    return mOptions[UnityshellOptions::MenusDiscoveryFadeout].value ().i ();
}

inline void
UnityshellOptions::optionSetMenusDiscoveryFadeoutNotify (UnityshellOptions::ChangeNotify notify)
{
    mNotify[UnityshellOptions::MenusDiscoveryFadeout] = notify;
}

inline CompAction &
UnityshellOptions::optionGetAltTabForward ()
{
    return mOptions[UnityshellOptions::AltTabForward].value ().action ();
}

inline void
UnityshellOptions::optionSetAltTabForwardInitiate (CompAction::CallBack init)
{
    mOptions[UnityshellOptions::AltTabForward].value ().action ().setInitiate (init);
}

inline void
UnityshellOptions::optionSetAltTabForwardTerminate (CompAction::CallBack term)
{
    mOptions[UnityshellOptions::AltTabForward].value ().action ().setTerminate (term);
}

inline void
UnityshellOptions::optionSetAltTabForwardNotify (UnityshellOptions::ChangeNotify notify)
{
    mNotify[UnityshellOptions::AltTabForward] = notify;
}

inline CompAction &
UnityshellOptions::optionGetAltTabPrev ()
{
    return mOptions[UnityshellOptions::AltTabPrev].value ().action ();
}

inline void
UnityshellOptions::optionSetAltTabPrevInitiate (CompAction::CallBack init)
{
    mOptions[UnityshellOptions::AltTabPrev].value ().action ().setInitiate (init);
}

inline void
UnityshellOptions::optionSetAltTabPrevTerminate (CompAction::CallBack term)
{
    mOptions[UnityshellOptions::AltTabPrev].value ().action ().setTerminate (term);
}

inline void
UnityshellOptions::optionSetAltTabPrevNotify (UnityshellOptions::ChangeNotify notify)
{
    mNotify[UnityshellOptions::AltTabPrev] = notify;
}

inline CompAction &
UnityshellOptions::optionGetAltTabForwardAll ()
{
    return mOptions[UnityshellOptions::AltTabForwardAll].value ().action ();
}

inline void
UnityshellOptions::optionSetAltTabForwardAllInitiate (CompAction::CallBack init)
{
    mOptions[UnityshellOptions::AltTabForwardAll].value ().action ().setInitiate (init);
}

inline void
UnityshellOptions::optionSetAltTabForwardAllTerminate (CompAction::CallBack term)
{
    mOptions[UnityshellOptions::AltTabForwardAll].value ().action ().setTerminate (term);
}

inline void
UnityshellOptions::optionSetAltTabForwardAllNotify (UnityshellOptions::ChangeNotify notify)
{
    mNotify[UnityshellOptions::AltTabForwardAll] = notify;
}

inline CompAction &
UnityshellOptions::optionGetAltTabPrevAll ()
{
    return mOptions[UnityshellOptions::AltTabPrevAll].value ().action ();
}

inline void
UnityshellOptions::optionSetAltTabPrevAllInitiate (CompAction::CallBack init)
{
    mOptions[UnityshellOptions::AltTabPrevAll].value ().action ().setInitiate (init);
}

inline void
UnityshellOptions::optionSetAltTabPrevAllTerminate (CompAction::CallBack term)
{
    mOptions[UnityshellOptions::AltTabPrevAll].value ().action ().setTerminate (term);
}

inline void
UnityshellOptions::optionSetAltTabPrevAllNotify (UnityshellOptions::ChangeNotify notify)
{
    mNotify[UnityshellOptions::AltTabPrevAll] = notify;
}

inline CompAction &
UnityshellOptions::optionGetAltTabNextWindow ()
{
    return mOptions[UnityshellOptions::AltTabNextWindow].value ().action ();
}

inline void
UnityshellOptions::optionSetAltTabNextWindowInitiate (CompAction::CallBack init)
{
    mOptions[UnityshellOptions::AltTabNextWindow].value ().action ().setInitiate (init);
}

inline void
UnityshellOptions::optionSetAltTabNextWindowTerminate (CompAction::CallBack term)
{
    mOptions[UnityshellOptions::AltTabNextWindow].value ().action ().setTerminate (term);
}

inline void
UnityshellOptions::optionSetAltTabNextWindowNotify (UnityshellOptions::ChangeNotify notify)
{
    mNotify[UnityshellOptions::AltTabNextWindow] = notify;
}

inline CompAction &
UnityshellOptions::optionGetAltTabPrevWindow ()
{
    return mOptions[UnityshellOptions::AltTabPrevWindow].value ().action ();
}

inline void
UnityshellOptions::optionSetAltTabPrevWindowInitiate (CompAction::CallBack init)
{
    mOptions[UnityshellOptions::AltTabPrevWindow].value ().action ().setInitiate (init);
}

inline void
UnityshellOptions::optionSetAltTabPrevWindowTerminate (CompAction::CallBack term)
{
    mOptions[UnityshellOptions::AltTabPrevWindow].value ().action ().setTerminate (term);
}

inline void
UnityshellOptions::optionSetAltTabPrevWindowNotify (UnityshellOptions::ChangeNotify notify)
{
    mNotify[UnityshellOptions::AltTabPrevWindow] = notify;
}

inline bool
UnityshellOptions::optionGetSwitchStrictlyBetweenApplications ()
{
    return mOptions[UnityshellOptions::SwitchStrictlyBetweenApplications].value ().b ();
}

inline void
UnityshellOptions::optionSetSwitchStrictlyBetweenApplicationsNotify (UnityshellOptions::ChangeNotify notify)
{
    mNotify[UnityshellOptions::SwitchStrictlyBetweenApplications] = notify;
}

inline bool
UnityshellOptions::optionGetShowMinimizedWindows ()
{
    return mOptions[UnityshellOptions::ShowMinimizedWindows].value ().b ();
}

inline void
UnityshellOptions::optionSetShowMinimizedWindowsNotify (UnityshellOptions::ChangeNotify notify)
{
    mNotify[UnityshellOptions::ShowMinimizedWindows] = notify;
}

inline bool
UnityshellOptions::optionGetAltTabTimeout ()
{
    return mOptions[UnityshellOptions::AltTabTimeout].value ().b ();
}

inline void
UnityshellOptions::optionSetAltTabTimeoutNotify (UnityshellOptions::ChangeNotify notify)
{
    mNotify[UnityshellOptions::AltTabTimeout] = notify;
}

inline bool
UnityshellOptions::optionGetAltTabBiasViewport ()
{
    return mOptions[UnityshellOptions::AltTabBiasViewport].value ().b ();
}

inline void
UnityshellOptions::optionSetAltTabBiasViewportNotify (UnityshellOptions::ChangeNotify notify)
{
    mNotify[UnityshellOptions::AltTabBiasViewport] = notify;
}

inline bool
UnityshellOptions::optionGetDisableShowDesktop ()
{
    return mOptions[UnityshellOptions::DisableShowDesktop].value ().b ();
}

inline void
UnityshellOptions::optionSetDisableShowDesktopNotify (UnityshellOptions::ChangeNotify notify)
{
    mNotify[UnityshellOptions::DisableShowDesktop] = notify;
}

inline bool
UnityshellOptions::optionGetDisableMouse ()
{
    return mOptions[UnityshellOptions::DisableMouse].value ().b ();
}

inline void
UnityshellOptions::optionSetDisableMouseNotify (UnityshellOptions::ChangeNotify notify)
{
    mNotify[UnityshellOptions::DisableMouse] = notify;
}



#endif
